﻿/* EntitiesToDTOs. Copyright (c) 2011. Fabian Fernandez.
 * http://entitiestodtos.codeplex.com
 * Licensed by Common Development and Distribution License (CDDL).
 * http://entitiestodtos.codeplex.com/license
 * Fabian Fernandez. 
 * http://www.linkedin.com/in/fabianfernandezb/en
 * */
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using EntitiesToDTOs.Properties;

namespace EntitiesToDTOs.Helpers
{
    /// <summary>
    /// Manages operations relative to the TemplateFile used to create ProjectItems
    /// </summary>
    internal class TemplateClass
    {
        /// <summary>
        /// Creates the TemplateFile in the File System
        /// </summary>
        public static void CreateFile()
        {
            TemplateClass.Delete();

            using (var templateClassFile = File.CreateText(Resources.TemplateClassPath))
            {
                templateClassFile.Write(string.Empty);

                templateClassFile.Flush();
                templateClassFile.Close();
                templateClassFile.Dispose();
            }
        }

        /// <summary>
        /// Deletes the TemplateFile from the File System
        /// </summary>
        public static void Delete()
        {
            if (File.Exists(Resources.TemplateClassPath))
            {
                File.Delete(Resources.TemplateClassPath);
            }
        }
    }
}