﻿/* EntitiesToDTOs. Copyright (c) 2012. Fabian Fernandez.
 * http://entitiestodtos.codeplex.com
 * Licensed by Common Development and Distribution License (CDDL).
 * http://entitiestodtos.codeplex.com/license
 * Fabian Fernandez. 
 * http://www.linkedin.com/in/fabianfernandezb/en
 * */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EntitiesToDTOs.Domain
{
    /// <summary>
    /// Represents the EntitiesToDTOs AddIn general configuration.
    /// </summary>
    internal class AddInConfig
    {
        /// <summary>
        /// Release status filter to use when checking for updates.
        /// </summary>
        public List<ReleaseStatus> ReleaseStatusFilter { get; set; }

        /// <summary>
        /// IDs of skipped releases.
        /// </summary>
        public List<int> SkippedReleases { get; set; }



        /// <summary>
        /// Creates a new instance of <see cref="AddInConfig"/>.
        /// </summary>
        public AddInConfig()
        {
            this.ReleaseStatusFilter = new List<ReleaseStatus>();
            this.SkippedReleases = new List<int>();
        }

    }
}